/* (C) Copyright 2009-2013 CNRS (Centre National de la Recherche Scientifique).

Licensed to the CNRS under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The CNRS licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.

*/

/* Contributors:

Luc Hogie (CNRS, I3S laboratory, University of Nice-Sophia Antipolis) 

*/
 
 
package cnrs.i3s.papareto.demo.tsp;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;

import cnrs.i3s.papareto.NewChildOperator;
import cnrs.i3s.papareto.NoRepresentation;
import cnrs.i3s.papareto.Population;
import cnrs.i3s.papareto.Representation;
import cnrs.i3s.papareto.impl.bytes.FixedLengthByteArrayRepresentation;
import toools.text.TextUtilities;

public class Main
{
	public static void main(String[] args)
	{
		int nbCities = 5;
		Map m = new Map(nbCities);
		m.randomize();


		Representation<Travel, Travel> r = new NoRepresentation<>();

		r.getRandomGenerators().add(new FixedLengthByteArrayRepresentation(nbCities)
		{
		});
		
		<Travel<Travel, Travel>()
		{
			@Override
			public Travel createNewChild(Population<Travel, Travel> p, Random r)
			{
				List<Integer> a = new ArrayList<>();

				for (int c = 0; c < nbCities; ++c)
				{
					a.add(c);
				}

				Collections.shuffle(a);
				Travel t = new Travel(nbCities, m);

				for (int c = 0; c < nbCities; ++c)
				{
					t.cities[c] = a.get(c);
				}

				return t;
			}
		});	
		
		r.getRandomGenerators().add(new NewChildOperator<Travel, Travel>()
		{
			@Override
			public Travel createNewChild(Population<Travel, Travel> p, Random r)
			{
				List<Integer> a = new ArrayList<>();

				for (int c = 0; c < nbCities; ++c)
				{
					a.add(c);
				}

				Collections.shuffle(a);
				Travel t = new Travel(nbCities, m);

				for (int c = 0; c < nbCities; ++c)
				{
					t.cities[c] = a.get(c);
				}

				return t;
			}
		});
		
		r.getCrossoverOperators().add(new NewChildOperator<Travel, Travel>()
		{
			@Override
			public Travel createNewChild(Population<Travel, Travel> p, Random r)
			{
				Travel t = new Travel(nbCities, m);


				return t;
			}
		});
		
		Population<Travel, Travel> p = new Population<>();

	}

}
