/* (C) Copyright 2009-2013 CNRS (Centre National de la Recherche Scientifique).

Licensed to the CNRS under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The CNRS licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.

*/

/* Contributors:

Luc Hogie (CNRS, I3S laboratory, University of Nice-Sophia Antipolis) 
Aurelien Lancin (Coati research team, Inria)
Christian Glacet (LaBRi, Bordeaux)
David Coudert (Coati research team, Inria)
Fabien Crequis (Coati research team, Inria)
Grégory Morel (Coati research team, Inria)
Issam Tahiri (Coati research team, Inria)
Julien Fighiera (Aoste research team, Inria)
Laurent Viennot (Gang research-team, Inria)
Michel Syska (I3S, Université Cote D'Azur)
Nathann Cohen (LRI, Saclay) 
Julien Deantoin (I3S, Université Cote D'Azur, Saclay) 

*/
 
 

package grph.oo;

import java.util.Collection;
import java.util.Iterator;

import com.carrotsearch.hppc.ObjectCollection;
import com.carrotsearch.hppc.cursors.ObjectCursor;

import toools.NotYetImplementedException;

class HPPCCollection2JavaCollection<V> implements Collection<V>
{
	private ObjectCollection<V> c;

	public HPPCCollection2JavaCollection(ObjectCollection<V> c)
	{
		this.c = c;
	}

	@Override
	public boolean add(V arg0)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public boolean addAll(Collection<? extends V> arg0)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public void clear()
	{
		throw new NotYetImplementedException();
	}

	@Override
	public boolean contains(Object o)
	{
		return c.contains((V) o);
	}

	@Override
	public boolean containsAll(Collection<?> otherCollection)
	{
		if (otherCollection.size() > size())
		{
			return false;
		}
		else
		{
			for (Object o : otherCollection)
			{
				if (!contains(o))
				{
					return false;
				}
			}

			return true;
		}
	}

	@Override
	public boolean isEmpty()
	{
		return c.isEmpty();
	}

	@Override
	public Iterator<V> iterator()
	{
		final Iterator<ObjectCursor<V>> i = c.iterator();
		return new Iterator<V>()
		{

			@Override
			public boolean hasNext()
			{
				return i.hasNext();
			}

			@Override
			public V next()
			{
				return i.next().value;
			}

			@Override
			public void remove()
			{
				i.remove();
			}

		};
	}

	@Override
	public boolean remove(Object e)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public boolean removeAll(Collection<?> arg0)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public boolean retainAll(Collection<?> arg0)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public int size()
	{
		return c.size();
	}

	@Override
	public Object[] toArray()
	{
		return c.toArray();
	}

	@Override
	public <T> T[] toArray(T[] a)
	{
		throw new NotYetImplementedException();
	}

}
