/* (C) Copyright 2009-2013 CNRS (Centre National de la Recherche Scientifique).

Licensed to the CNRS under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The CNRS licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.

*/

/* Contributors:

Luc Hogie (CNRS, I3S laboratory, University of Nice-Sophia Antipolis) 
Aurelien Lancin (Coati research team, Inria)
Christian Glacet (LaBRi, Bordeaux)
David Coudert (Coati research team, Inria)
Fabien Crequis (Coati research team, Inria)
Grégory Morel (Coati research team, Inria)
Issam Tahiri (Coati research team, Inria)
Julien Fighiera (Aoste research team, Inria)
Laurent Viennot (Gang research-team, Inria)
Michel Syska (I3S, Université Cote D'Azur)
Nathann Cohen (LRI, Saclay) 
Julien Deantoin (I3S, Université Cote D'Azur, Saclay) 

*/
 
 package toools.set;

import java.util.Iterator;
import java.util.Random;

import toools.NotYetImplementedException;

import com.carrotsearch.hppc.IntContainer;
import com.carrotsearch.hppc.cursors.IntCursor;

public final class UnmodifiableHPPCIntContainerIntSet extends IntSet
{
	private final IntContainer c;

	public UnmodifiableHPPCIntContainerIntSet(IntContainer c)
	{
		this.c = c;
	}

	@Override
	public Class<?> getImplementationClass()
	{
		return c.getClass();
	}

	@Override
	public Iterator<IntCursor> iterator()
	{
		return c.iterator();
	}

	@Override
	public boolean contains(int id)
	{
		return c.contains(id);
	}

	@Override
	public int size()
	{
		return c.size();
	}

	@Override
	public boolean isEmpty()
	{
		return c.isEmpty();
	}

	@Override
	public int pickRandomElement(Random prng)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public int getGreatest()
	{
		throw new NotYetImplementedException();
	}

	@Override
	public void add(int id)
	{
		throw new NotYetImplementedException();

	}

	@Override
	public void remove(int id)
	{
		throw new NotYetImplementedException();
	}

	@Override
	public void clear()
	{
		throw new NotYetImplementedException();
	}

}
